;
;	MZ-700ŃOtBbNǂ
;
HBLNK	EQU	0E008H
VBLNK	EQU	0E002H

JANUX	EQU	16
JANDX	EQU	33

IMGSIZE	EQU	2178

IMG_GUU		EQU	2178
IMG_CHOKI	EQU	4536		;2178*2
IMG_PAA		EQU	6534		;2178*3
IMG_TITLE	EQU	8712		;2178*4
IMG_GOVER	EQU	10890		;2178*5
IMG_G0		EQU	13068		;2178*6
IMG_G1		EQU	15246		;2178*7
IMG_G2		EQU	17424		;2178*8
IMG_G3		EQU	19602		;2178*9
IMG_G10		EQU	21780		;2178*10
IMG_G11		EQU	23958		;2178*11
IMG_G12		EQU	26136		;2178*12
IMG_G13		EQU	28314		;2178*12

	ORG	1200H

y2k_main:
	DI
	OUT	(0E0H),A	;DRAM bank(0000h) for workarea
mainentry:
	CALL	clearscreen2
	LD	HL,msg_title
	LD	DE,0D000H+204
	CALL	printmsg
	LD	HL,msg_pushspc
	LD	DE,0D000H+932
	CALL	printmsg
	LD	HL,titleseq
	CALL	SHOWANIM

	XOR	A
	LD	(fukustate),A
	LD	(janlosecnt),A
mainlp:
	CALL	jankenmain
	JR	C,gameover

	LD	A,(fukustate)
	OR	A
	JR	NZ,mainl0

	INC	A
	LD	(fukustate),A
	CALL	clearscreen2
	LD	HL,fuku0
	CALL	SHOWANIM
	JP	mainlp

mainl0:	CP	1
	JR	NZ,mainl1
	INC	A
	LD	(fukustate),A
	CALL	clearscreen2
	LD	HL,fuku1
	CALL	SHOWANIM
	JP	mainlp

mainl1:

gameover:
	CALL	clearscreen2
	LD	HL,msg_gover
	LD	DE,0D000H+931
	CALL	printmsg
	LD	HL,goverseq
	CALL	SHOWANIM
	JP	mainentry

xit:
	OUT	(0E2H),A	;IPL ROM bank
	JP	00ADH

fukustate:
	DEFB	0

fuku0:
	DEFB	26
	DEFW	IMAGETOP+IMG_G0
	DEFW	cbnop
	DEFB	200
	DEFW	IMAGETOP+IMG_G1
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G2
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G3
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G3
	DEFW	printpushspc
	DEFB	1
	DEFW	IMAGETOP+IMG_G3
	DEFW	pushspckey
	DEFB	255

fuku1:
	DEFB	26
	DEFW	IMAGETOP+IMG_G10
	DEFW	cbnop
	DEFB	200
	DEFW	IMAGETOP+IMG_G11
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G12
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G13
	DEFW	cbnop
	DEFB	12
	DEFW	IMAGETOP+IMG_G13
	DEFW	printpushspc
	DEFB	1
	DEFW	IMAGETOP+IMG_G13
	DEFW	pushspckey
	DEFB	255

titleseq:
	DEFB	34
	DEFW	IMAGETOP+IMG_TITLE
	DEFW	pushspckey
	DEFB	255
goverseq:
	DEFB	25
	DEFW	IMAGETOP+IMG_GOVER
	DEFW	cbnop
	DEFB	255
	DEFW	IMAGETOP+IMG_GOVER
	DEFW	cbfin
	DEFB	1
cbfin:	LD	A,1
	RET
pushspckey:
	LD	HL,0E000H	; "push space key"
	LD	(HL),6
	INC	HL
	LD	A,(HL)
	AND	010H
	LD	A,1		; finish
	RET	Z
	INC	A		; continue
	RET
msg_title:
	DEFB	17
	DEFB	044H		;
	DEFB	044H		;
	DEFB	000H
	DEFB	0A7H		;
	DEFB	087H		;
	DEFB	0B3H		;
	DEFB	0A4H		;
	DEFB	09CH		;
	DEFB	099H		;
	DEFB	000H
	DEFB	022H		;2
	DEFB	020H		;0
	DEFB	020H		;0
	DEFB	020H		;0
	DEFB	000H
	DEFB	044H		;
	DEFB	044H		;
msg_pushspc:
	DEFB	16
	DEFB	010H		;P
	DEFB	015H		;U
	DEFB	013H		;S
	DEFB	008H		;H
	DEFB	0
	DEFB	052H		;[
	DEFB	013H		;S
	DEFB	010H		;P
	DEFB	001H		;A
	DEFB	003H		;C
	DEFB	005H		;E
	DEFB	054H		;]
	DEFB	0
	DEFB	00BH		;K
	DEFB	005H		;E
	DEFB	019H		;Y
msg_gover:
	DEFB	15
	DEFB	044H		;
	DEFB	044H		;
	DEFB	000H
	DEFB	007H		;G
	DEFB	001H		;A
	DEFB	00DH		;M
	DEFB	005H		;E
	DEFB	000H
	DEFB	00FH		;O
	DEFB	016H		;V
	DEFB	005H		;E
	DEFB	012H		;R
	DEFB	000H
	DEFB	044H		;
	DEFB	044H		;
printmsg:			; HL=MSGADDR(LDISPC), DE=VRAMADDR
	LD	C,(HL)
	INC	HL
	LD	B,0
	LDIR
	RET
printpushspc:
	LD	HL,msg_pushspc
	LD	DE,0D000H+932
	CALL	printmsg
	XOR	A
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	񂯂񃋁[`
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
jankenmain:
jaiko:	CALL	clearscreen		; init screen
	LD	A,(janlosecnt)
	OR	A
	JR	Z,janm1
	LD	DE,0D000H+35+40
clsl0:	CALL	drawbatsu
	DEC	DE
	DEC	DE
	DEC	DE
	DEC	DE
	DEC	DE
	DEC	A
	JR	NZ,clsl0

janm1:	CALL	janken
	LD	A,(janmyhand)
	LD	B,A
	LD	A,(janghand)
	CP	B
	JR	Z,jaiko			;
	DJNZ	janm0
	LD	B,3
janm0:	CP	B
	JP	NZ,jkachi		;
	LD	A,(janlosecnt)
	INC	A
	LD	(janlosecnt),A
	CP	3			;lose > 3: Cy=0
	CCF				;lose > 3: Cy=1
	RET	C			;Q[I[o[FCy=1
	JR	jaiko
jkachi:	XOR	A			;FCy=0
	RET

clearscreen:
	LD	HL,0D000H
	LD	DE,0D001H
	LD	BC,880		;40*22
	LD	(HL),043H
	LDIR
	LD	(HL),0
	LD	C,120
	LDIR
	LD	HL,0D800H
	LD	DE,0D801H
	LD	BC,880		;40*22
	LD	(HL),070H
	LDIR
	LD	(HL),0F0H
	LD	C,120		;40*3
	LDIR
	RET

clearscreen2:
	LD	HL,0D000H
	LD	DE,0D001H
	LD	BC,999		;40*25-1
	LD	(HL),L
	LDIR
	LD	HL,0D800H
	LD	DE,0D801H
	LD	BC,880		;40*22
	LD	(HL),087H
	LDIR
	LD	(HL),070H
	LD	C,120		;40*3
	LDIR
	RET

drawbatsu:
	PUSH	AF
	PUSH	DE
	LD	HL,batsudat
	LD	A,4
drawb0:	LDI
	LDI
	LDI
	LDI
	LD	BC,40-4
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL
	DEC	A
	JR	NZ,drawb0
	POP	DE
	POP	AF
	RET
batsudat:
	DEFB	56H
	DEFB	42H
	DEFB	56H
	DEFB	42H
	DEFB	4DH
	DEFB	00H
	DEFB	00H
	DEFB	4EH
	DEFB	56H
	DEFB	00H
	DEFB	00H
	DEFB	42H
	DEFB	4DH
	DEFB	4EH
	DEFB	4DH
	DEFB	4EH

janken:
	LD	HL,TESTDATA
	XOR	A
	LD	(janstate),A
	INC	A
	LD	(janghand),A
	CALL	SHOWANIM2
	RET

; callback̕Ԃl:
;	0: Ȃ
;	1: Iiʂă^[j
;	2: ̃t[x\
;	3: ŏ\
TESTDATA:
	DEFB	25		; right most X
	DEFW	IMAGETOP+2178	; image address
	DEFW	jancallback	; callback function
	DEFB	25		; frame num
	DEFW	IMAGETOP	; image address
	DEFW	jancallback	; callback function
	DEFB	13		; frame num
	DEFW	IMAGETOP	; image address
	DEFW	janloopchk	; callback function
	DEFB	1		; frame num
	DEFW	0000H		; ʂ̎\
	DEFW	cbnop		; 
	DEFB	150		; 
	DEFW	0000H		; ʃbZ[W\
	DEFW	janresultmsg	; 
	DEFB	1		; 
	DEFW	0000H		; ҂ďI
	DEFW	janend		; 
	DEFB	255		; 

janstate:	DEFB	0
janmyhand:	DEFB	0
janghand:	DEFB	0
janmypicad:	DEFW	0
jangpicad:	DEFW	0
jandestad:	DEFW	0
jantranscnt:	DEFB	0
janlosecnt:	DEFB	0
jancallback:
	LD	A,(janstate)	;13
	ADD	A,A		;4
	LD	D,0		;7
	LD	E,A		;4
	LD	HL,janjtbl	;10
	ADD	HL,DE		;11
	LD	E,(HL)		;7
	INC	HL		;6
	LD	D,(HL)		;7
	EX	DE,HL		;4
	JP	(HL)		;4
janjtbl:
	DEFW	janst0
	DEFW	janst1
	DEFW	janst2
	DEFW	janst3
	DEFW	janst4
	DEFW	janst5
	DEFW	janst7
	DEFW	janst9

janst0:	LD	HL,0E000H		;L[̓`FbNA̎茈߁A]
	LD	(HL),5
	INC	HL
	LD	A,(HL)			; key sense
	LD	HL,janmyhand
	LD	B,1			; 1:gu
	RLA
	JP	NC,jst00
	INC	B			; 2:choki
	RLA
	JP	NC,jst00
	INC	B			; 3:paa
	RLA
	JP	NC,jst00		; no key pressed
	LD	HL,janghand		;roll girl's hand
	DEC	(HL)
	JR	NZ,jst02
	LD	(HL),3
jst02:	XOR	A			; nop
	RET
jst00:	LD	(HL),B			; key pressed
	LD	HL,janstate
	INC	(HL)
cbnop:	XOR	A
	RET

janst1:	LD	HL,IMAGETOP+121		;lower half
	LD	A,(janmyhand)
	LD	B,A
	LD	DE,2178
jst10:	ADD	HL,DE
	DJNZ	jst10
	LD	(janmypicad),HL
	LD	HL,IMAGETOP		;upper half
	LD	A,(janghand)
	LD	B,A
jst11:	ADD	HL,DE
	DJNZ	jst11
	LD	(jangpicad),HL
	LD	HL,0
	LD	(jandestad),HL
	LD	A,11
	LD	(jantranscnt),A
	LD	HL,janstate
	INC	(HL)
	XOR	A
	RET

janst2:	LD	HL,(jangpicad)		;㔼̎@Agr[g]
	LD	DE,(jandestad)
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LD	(jangpicad),HL
	LD	(jandestad),DE
	LD	HL,jantranscnt
	DEC	(HL)
	JP	Z,jst20
	XOR	A
	RET
jst20:	LD	(HL),11
	LD	HL,janstate
	LD	(HL),3
	XOR	A
	RET

janst3:	LD	HL,(janmypicad)		;̎@Agr[g]
	LD	DE,(jandestad)
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LD	(janmypicad),HL
	LD	(jandestad),DE
	LD	HL,jantranscnt
	DEC	(HL)
	JP	Z,jst30
	XOR	A
	RET
jst30:	LD	(HL),44
	LD	HL,janstate
	LD	(HL),4
	XOR	A
	RET

janst4:	LD	HL,(janmypicad)
	LD	BC,968			; 11*88i㔼̎̃Lf[^΂j
	ADD	HL,BC
	LD	(janmypicad),HL
	LD	HL,(jangpicad)
	LD	BC,121			; 11*11i̎̃Agr[g΂j
	ADD	HL,BC
	LD	(jangpicad),HL
	LD	HL,janstate
	LD	(HL),5
	XOR	A
	RET

janst5:	LD	HL,(jangpicad)		;㔼̎@LN^]
	LD	DE,(jandestad)
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LD	(jangpicad),HL
	LD	(jandestad),DE
	LD	HL,jantranscnt
	DEC	(HL)
	JP	Z,jst50
	XOR	A
	RET
jst50:	LD	(HL),44
	LD	HL,janstate
	LD	(HL),6
	XOR	A
	RET

janst7:	LD	HL,(janmypicad)		;̎@LN^]
	LD	DE,(jandestad)
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LDI
	LD	(janmypicad),HL
	LD	(jandestad),DE
	LD	HL,jantranscnt
	DEC	(HL)
	JP	Z,jst70
	XOR	A
	RET
jst70:	LD	HL,janstate
	LD	(HL),7
	XOR	A
	RET

janst9:	XOR	A			;transfer complete
	RET

janloopchk:
	LD	A,(janstate)
	CP	5
	JR	NZ,jlchk0
	LD	HL,0D000H+928		; 23*40+8
	LD	(HL),084H		;
	INC	HL
	LD	(HL),0BCH		;J
	INC	HL
	LD	(HL),09FH		;
	INC	HL
	LD	(HL),099H		;
	JR	jlchk9
jlchk0:	CP	6
	JR	NZ,jlchk2
	LD	HL,0D000H+939		; 23*40+19
	LD	(HL),09CH		;
	INC	HL
	LD	(HL),099H		;
jlchk9:	LD	A,3			;get back to top
	RET
jlchk2:	CP	7
	JR	NZ,jlchk9
	LD	HL,0D000H+948		; 23*40+28
	LD	(HL),0AAH		;
	INC	HL
	LD	(HL),0B8H		;K
	INC	HL
	LD	(HL),099H		;
	INC	HL
	LD	(HL),061H		;I
	XOR	A
	LD	(jantranscnt),A
	RET

janend:	LD	HL,jantranscnt		;wait 255 frame and exit
	DEC	(HL)
	LD	A,1
	RET	Z
	INC	A
	RET

janresultmsg:
	LD	HL,0D000H+928		; 23*40+8
	XOR	A
	LD	B,24
janr1:	LD	(HL),A
	INC	HL
	DJNZ	janr1
	LD	HL,msg_aiko
	LD	DE,0D000H+936		; 23*40+16
	LD	A,(janmyhand)
	LD	B,A
	LD	A,(janghand)
	CP	B
	JR	Z,janr2			;
	DJNZ	janr0
	LD	B,3
janr0:	LD	HL,msg_kachi
	CP	B
	JP	NZ,janr2		;
	LD	HL,msg_make
janr2:	LD	BC,8
	LDIR
	XOR	A
	RET
msg_kachi:
	DEFB	0A3H			;
	DEFB	095H			;
	DEFB	091H			;
	DEFB	08BH			;
	DEFB	000H			;
	DEFB	094H			;
	DEFB	081H			;
	DEFB	061H			;I
msg_make:
	DEFB	0A3H			;
	DEFB	095H			;
	DEFB	091H			;
	DEFB	08BH			;
	DEFB	000H			;
	DEFB	08AH			;
	DEFB	09CH			;
	DEFB	061H			;I
msg_aiko:
	DEFB	000H			;
	DEFB	000H			;
	DEFB	0A3H			;
	DEFB	085H			;
	DEFB	082H			;
	DEFB	061H			;I
	DEFB	000H			;
	DEFB	000H			;
;
;	Aj[V\
;	IN:	HL = t[f[^AhX
;			
;			ŏ̉摜͂Qt[Ԉȏ\邱
;			e摜f[^VRAMoN̗ɂȂȂ悤ɔzu邱
;
;	[NGA
;
IMGDATA:	DEFW	0		; start addr of control sequence
CURRIMGPTR:	DEFW	0		; current ptr in the image control sequence
NEXTATTR:	DEFW	0
CALLBACK:	DEFW	0		; callback function IY,SPȊO͔j󂵂Ăǂ
SAVSTKP:		DEFW	0
RIGHTMOST:	DEFB	0		; E[̂wW
		DEFB	0		; (for word read)
FRAMECOUNT:	DEFB	0		; t[JEg

SHOWANIM:					; Gg
	DI
	OUT	(0E3H),A			; VRAM bank
	LD	(SAVSTKP),SP			; save SP
	LD	A,(HL)
	LD	(RIGHTMOST),A
	INC	HL
	LD	(IMGDATA),HL			; save start addr of frame data
	LD	(CURRIMGPTR),HL		; current ptr in control sequence

	LD	SP,HL			;\̏
	POP	HL
	LD	(NEXTATTR),HL		;ԍŏ͎t[ωȂƉ肷
	POP	HL
	LD	(CALLBACK),HL
	POP	HL
	LD	A,L
	LD	(FRAMECOUNT),A

	; clear image area
	LD	HL,(RIGHTMOST)
	LD	H,0D0H
	LD	DE,51				; 40 + 11
	XOR	A
	LD	C,22
SAL001:	LD	B,11
SAL000:	LD	(HL),A
	DEC	HL
	DJNZ	SAL000
	DEC	C
	ADD	HL,DE
	JR	NZ,SAL001

	; init attribute with 1st frame data
	LD	DE,(NEXTATTR)		; read 1st image data to DE
	LD	H,0D8H
	LD	A,(RIGHTMOST)
	SUB	10
	LD	L,A
	LD	C,22
SAL003:	LD	B,11
SAL002:	LD	A,(DE)			; read attr data
	INC	DE
	LD	(HL),A
	INC	HL
	DJNZ	SAL002
	LD	A,C			; save y-loop
	LD	C,29			; 40 - 11
	ADD	HL,BC
	LD	C,A			; restore y-loop
	DEC	C
	JR	NZ,SAL003

	LD	IX,0
	ADD	IX,DE			; start of image data(chr)

;;; Timing Critical Section Start ;;;

ANIMENTRY:
	LD	HL,VBLNK			;uNԂ̊Jn҂
	LD	A,7FH
SAL1:	CP	(HL)
	JP	NC,SAL1
SAL2:	CP	(HL)
	JP	C,SAL2


LOOP:	LD	IY,0D000H			;VRAMAhX(̍Ō)
	LD	BC,(RIGHTMOST)
	ADD	IY,BC

	LD	SP,IX				;PX^ڂ`Ă
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC
	LD	BC,11
	ADD	IX,BC

	LD	HL,VBLNK			;X^[g҂
	LD	A,7FH
SAL3:	CP	(HL)
	JP	NC,SAL3				;uNԂ̏I҂

	LD	A,22				;22s[v
	JP	ENTRY1ST			;Osڂ̑1X^珑
						;X:27`45NbN(<76)
LOOP25:
	LD	SP,IX				;10 --- raster 0 update
	POP	BC				;10 \ԒVRAMɃEFCg
	POP	DE				;10 ɂȂ̂ŁA
	POP	HL				;10 VRAMɂ̓ANZXf[^
	EXX					;4  pӂĂB
	POP	BC				;10 \Ԃ160NbNB
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
						; --- total 84 clk ([vɂɎgcclk: 76)
	LD	(IY),L				;HBLNK start
	PUSH	DE				;11
	PUSH	BC				;11
	EXX					;4
	PUSH	HL				;11
	PUSH	DE				;11
	PUSH	BC				;11
						; --- total 59 clk (<60)
;\ԒVRAMANZXJnĂ
;m[EFCgVRAMANZX\ȊԁcUOCPUNbNiŏVRAMANZX܂܂j
	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15
ENTRY1ST:
	LD	SP,IX				; --- raster 1 update
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11
	ADD	IX,BC

	LD	SP,IX				; --- raster 2 update
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 3 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 4 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 5 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 6 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 7 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	C,40				;7  next (text-)line
	ADD	IY,BC				;15

	DEC	A				;4
	JP	NZ,LOOP25			;10
						; --- total 84 + 61 = 145 CPU clock (<160)

;	̃t[̃Agr[gĂ

	LD	IY,0D800H			;14 75
	LD	A,(0D000H)			;      \Ԓ̂͂Ȃ̂ŁAHBLNKɓ
	LD	BC,(RIGHTMOST)			;20    (PX^]ɂă^C~O킹)
	ADD	IY,BC				;15 35
	LD	IX,(NEXTATTR)			;20 55
	LD	A,22				; 7 62 HBLNK𔲂
LOOPATTR:
	LD	SP,IX				;10 --- raster 7 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	C,40				;7
	ADD	IY,BC				;15

	DEC	A				;4
	JP	NZ,LOOPATTR			;10

;
;	VBLNK̏
;
ANIMVBLNK:
	LD	HL,(CALLBACK)		; process callback function
;;;	LD	SP,(SAVSTKP)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	SAVSTKP			;workaround
	CALL	CBDUMMY
	OR	A
	JP	Z,SAL901		; ret val == 0 (nop)
	DEC	A
	JP	Z,ANIMEND		; ret val == 1 (finish)
	DEC	A
	JP	NZ,SAL802		; ret val == 2 (stay on this frame)
	LD	A,2
	LD	(FRAMECOUNT),A
	JP	SAL901
SAL802:	DEC	A
	JP	NZ,SAL901
;;;	LD	SP,(IMGDATA)		; ret val == 3 (get back to 1st frame)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	IMGDATA			;workaround
	JP	SAL902
CBDUMMY:
	JP	(HL)

SAL901:	LD	HL,FRAMECOUNT		; if FRAMECOUNT expired,
	DEC	(HL)
	JP	NZ,SAL900
;;;	LD	SP,(CURRIMGPTR)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	CURRIMGPTR		;workaround
	INC	SP			; advance current ptr
	INC	SP
	INC	SP
	INC	SP
	INC	SP
SAL902:	LD	(CURRIMGPTR),SP	; next ptr in img ctrl sequence
	POP	HL
	LD	(NEXTATTR),HL		; init next image data top address
	POP	HL
	LD	(CALLBACK),HL		; init callback addr
	POP	HL
	LD	A,L
	LD	(FRAMECOUNT),A		; init next frame count
SAL900:
;
;	VBLNK̏ I
;
;;;	LD	HL,VBLNK			;uNԂ܂ő҂
;;;	LD	A,7FH				;iԂ҂ȂĂĂ͂j
;;;SAL999:	CP	(HL)
;;;	JR	C,SAL999
	JP	LOOP

ANIMEND:					;Agr[gNAďI
	LD	HL,(RIGHTMOST)
	LD	H,0D8H
	LD	SP,HL
	LD	DE,7777H			;PX^ڂ𔒂ŃNA
	LD	(HL),E
	PUSH	DE
	PUSH	DE
	PUSH	DE
	PUSH	DE
	PUSH	DE

	LD	B,8				;[vrɔэݗp

	EXX
	LD	HL,VBLNK			;X^[g҂
	LD	A,7FH
SAL990:	CP	(HL)
	JP	NC,SAL990			;uNԂ̏I҂
	EXX

	LD	A,22				;22s[v
	JP	ENDL00				;Osڂ̑1X^珑
						;X:38`56NbN(<76)
ENDL26:	LD	B,8				; 7
ENDL25:
	LD	SP,HL				;10
						; --- total 10 clk ([vɂɎgcclk: 150)
	LD	(HL),E				;HBLNK start
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
						; --- total 55 clk (<60)
ENDL00:	DJNZ	ENDL25				;13(jump)/8
	LD	C,40				; 7
	ADD	HL,BC				;11
	DEC	A				; 4
	JP	NZ,ENDL26			;10

;;; End of timing critical section ;;;

;;;	LD	SP,(SAVSTKP)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	SAVSTKP			;workaround
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SHOWANIM2:					; 񂯂\
	DI
	OUT	(0E3H),A			; VRAM bank
	LD	(SAVSTKP),SP			; save SP
	INC	HL
	LD	(IMGDATA),HL			; save start addr of frame data
	LD	(CURRIMGPTR),HL		; current ptr in control sequence

	LD	SP,HL			;\̏
	POP	HL
	LD	(NEXTATTR),HL		;ԍŏ͎t[ωȂƉ肷
	POP	HL
	LD	(CALLBACK),HL
	POP	HL
	LD	A,L
	LD	(FRAMECOUNT),A

	; clear image area
	LD	L,JANUX
	LD	H,0D0H
	LD	DE,51				; 40 + 11
	XOR	A
	LD	C,11
SAL101:	LD	B,11
SAL100:	LD	(HL),A
	DEC	HL
	DJNZ	SAL100
	DEC	C
	ADD	HL,DE
	JR	NZ,SAL101
	LD	C,JANDX-JANUX
	ADD	HL,BC
	LD	C,11
SAL111:	LD	B,11
SAL110:	LD	(HL),A
	DEC	HL
	DJNZ	SAL110
	DEC	C
	ADD	HL,DE
	JR	NZ,SAL111

	; init attribute with 1st frame data
	LD	DE,(NEXTATTR)		; read 1st image data to DE
	LD	H,0D8H
	LD	L,JANUX-10
	LD	C,11
SAL103:	LD	B,11
SAL102:	LD	A,(DE)			; read attr data
	INC	DE
	LD	(HL),A
	INC	HL
	DJNZ	SAL102
	LD	A,C			; save y-loop
	LD	C,29			; 40 - 11
	ADD	HL,BC
	LD	C,A			; restore y-loop
	DEC	C
	JR	NZ,SAL103
	LD	C,JANDX-JANUX
	ADD	HL,BC
	LD	C,11
SAL113:	LD	B,11
SAL112:	LD	A,(DE)			; read attr data
	INC	DE
	LD	(HL),A
	INC	HL
	DJNZ	SAL112
	LD	A,C			; save y-loop
	LD	C,29			; 40 - 11
	ADD	HL,BC
	LD	C,A			; restore y-loop
	DEC	C
	JR	NZ,SAL113

	LD	IX,0
	ADD	IX,DE			; start of image data(chr)

;;; Timing Critical Section Start ;;;

ANIM2ENTRY:
	LD	HL,VBLNK			;uNԂ̊Jn҂
	LD	A,7FH
SAL1_1:	CP	(HL)
	JP	NC,SAL1_1
SAL2_1:	CP	(HL)
	JP	C,SAL2_1


LOOP_2:	LD	IY,0D000H+JANUX			;VRAMAhX(̍Ō)

	LD	SP,IX				;PX^ڂ`Ă
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC
	LD	BC,11
	ADD	IX,BC

	LD	HL,VBLNK			;X^[g҂
	LD	A,7FH
SAL3_1:	CP	(HL)
	JP	NC,SAL3_1			;uNԂ̏I҂

	LD	A,22				;22s[v
	JP	ENTRY1ST2			;Osڂ̑1X^珑
						;X:27`45NbN(<76)
LOOP25_2:
	LD	SP,IX				;10 --- raster 0 update
	POP	BC				;10 \ԒVRAMɃEFCg
	POP	DE				;10 ɂȂ̂ŁA
	POP	HL				;10 VRAMɂ̓ANZXf[^
	EXX					;4  pӂĂB
	POP	BC				;10 \Ԃ160NbNB
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
						; --- total 84 clk ([vɂɎgcclk: 76)
	LD	(IY),L				;HBLNK start
	PUSH	DE				;11
	PUSH	BC				;11
	EXX					;4
	PUSH	HL				;11
	PUSH	DE				;11
	PUSH	BC				;11
						; --- total 59 clk (<60)
;\ԒVRAMANZXJnĂ
;m[EFCgVRAMANZX\ȊԁcUOCPUNbNiŏVRAMANZX܂܂j
	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15
ENTRY1ST2:
	LD	SP,IX				; --- raster 1 update
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11
	ADD	IX,BC

	LD	SP,IX				; --- raster 2 update
	POP	BC
	POP	DE
	POP	HL
	EXX
	POP	BC
	POP	DE
	POP	HL
	LD	SP,IY
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 3 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 4 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	SP,IX				;10 --- raster 5 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	HL,EMB01+1			;10 (embedded)
	LD	(HL),40				;10 (embedded)

	LD	SP,IX				;10 --- raster 6 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	HL,EMB01+1			;10        (embedded)
	CP	12				;7    17   (embedded)
	JR	NZ,EMB02			;7/12 24/29(embedded)
	LD	(HL),40+JANDX-JANUX		;10   34/29(embedded)
EMB02:

	LD	SP,IX				;10 --- raster 7 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10

	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15
EMB01:
	LD	C,40				;7  next (text-)line
	ADD	IY,BC				;15

	DEC	A				;4
	JP	NZ,LOOP25_2			;10
						; --- total 84 + 62 = 146 CPU clock (<160)

;	̃t[̃Agr[gĂ

	LD	IY,0D800H			;14 75
	LD	A,(0D000H)			;      \Ԓ̂͂Ȃ̂ŁAHBLNKɓ
	LD	BC,JANUX			;10  (PX^]ɂă^C~O킹)
	ADD	IY,BC				;15 25
	LD	IX,(NEXTATTR)			;20 45
	LD	A,11				; 7 52 [v̓rHBLNK𔲂
LOOPATTR2:
	LD	SP,IX				;10 --- raster 7 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	C,40				;7
	ADD	IY,BC				;15

	DEC	A				;4
	JP	NZ,LOOPATTR2			;10

	LD	C,JANDX-JANUX			; 7 69
	ADD	IY,BC				;15 84(PX^]ɂă^C~O킹)
	LD	A,(0D000H)			;      \Ԓ̂͂Ȃ̂ŁAHBLNKɓ
	LD	A,11				; 7
LOOPATTR3:
	LD	SP,IX				;10 --- raster 7 update
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	EXX					;4
	POP	BC				;10
	POP	DE				;10
	POP	HL				;10
	LD	SP,IY				;10
	
	LD	(IY),L
	PUSH	DE
	PUSH	BC
	EXX
	PUSH	HL
	PUSH	DE
	PUSH	BC

	LD	BC,11				;10 increment data pointer
	ADD	IX,BC				;15

	LD	C,40				;7
	ADD	IY,BC				;15

	DEC	A				;4
	JP	NZ,LOOPATTR3			;10

;
;	VBLNK̏
;
ANIM2VBLNK:
	LD	HL,(CALLBACK)		; process callback function
;;;	LD	SP,(SAVSTKP)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	SAVSTKP			;workaround
	CALL	CBDUMMY
	OR	A
	JP	Z,SAL911		; ret val == 0 (nop)
	DEC	A
	JP	Z,ANIM2END		; ret val == 1 (finish)
	DEC	A
	JP	NZ,SAL812		; ret val == 2 (stay on this frame)
	LD	A,2
	LD	(FRAMECOUNT),A
	JP	SAL911
SAL812:	DEC	A
	JP	NZ,SAL911
;;;	LD	SP,(IMGDATA)		; ret val == 3 (get back to 1st frame)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	IMGDATA			;workaround
	JP	SAL912

SAL911:	LD	HL,FRAMECOUNT		; if FRAMECOUNT expired,
	DEC	(HL)
	JP	NZ,SAL910
;;;	LD	SP,(CURRIMGPTR)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	CURRIMGPTR		;workaround
	INC	SP			; advance current ptr
	INC	SP
	INC	SP
	INC	SP
	INC	SP
SAL912:	LD	(CURRIMGPTR),SP	; next ptr in img ctrl sequence
	POP	HL
	LD	(NEXTATTR),HL		; init next image data top address
	POP	HL
	LD	(CALLBACK),HL		; init callback addr
	POP	HL
	LD	A,L
	LD	(FRAMECOUNT),A		; init next frame count
SAL910:
;
;	VBLNK̏ I
;
;;;	LD	HL,VBLNK			;uNԂ܂ő҂
;;;	LD	A,7FH				;iԂ҂ȂĂĂ͂j
;;;SAL999:	CP	(HL)
;;;	JR	C,SAL999
	JP	LOOP_2

ANIM2END:					;Agr[gNAďI
	LD	L,JANUX
	LD	H,0D8H
	LD	SP,HL
	LD	DE,7777H			;PX^ڂ𔒂ŃNA
	LD	(HL),E
	PUSH	DE
	PUSH	DE
	PUSH	DE
	PUSH	DE
	PUSH	DE

	LD	B,8				;[vrɔэݗp

	EXX
	LD	HL,VBLNK			;X^[g҂
	LD	A,7FH
SAL991:	CP	(HL)
	JP	NC,SAL991			;uNԂ̏I҂
	EXX

	LD	A,11				;22s[v
	JP	ENDL10				;Osڂ̑1X^珑
						;X:38`56NbN(<76)
ENDL36:	LD	B,8				; 7
ENDL35:
	LD	SP,HL				;10
						; --- total 10 clk ([vɂɎgcclk: 150)
	LD	(HL),E				;HBLNK start
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
						; --- total 55 clk (<60)
ENDL10:	DJNZ	ENDL35				;13(jump)/8
	LD	C,40				; 7
	ADD	HL,BC				;11
	DEC	A				; 4
	JP	NZ,ENDL36			;10

	LD	C,JANDX-JANUX			;
	ADD	HL,BC
	LD	A,11
ENDL46:	LD	B,8				; 7
ENDL45:
	LD	SP,HL				;10
						; --- total 10 clk ([vɂɎgcclk: 150)
	LD	(HL),E				;HBLNK start
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
	PUSH	DE				;11
						; --- total 55 clk (<60)
	DJNZ	ENDL45				;13(jump)/8
	LD	C,40				; 7
	ADD	HL,BC				;11
	DEC	A				; 4
	JP	NZ,ENDL46			;10


;;; End of timing critical section ;;;

;;;	LD	SP,(SAVSTKP)
	DEFB	0EDH			;workaround
	DEFB	07BH			;workaround
	DEFW	SAVSTKP			;workaround
	RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

IMAGETOP:

	END
